Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.cpp	(revision 12878)
@@ -9,6 +9,6 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-int MeshPartitionx(int** pepart, int** pnpart, int numberofelements,int numberofnodes,double* elements,
-		int numberofelements2d,int numberofnodes2d,double* elements2d,int numlayers,int elements_width, int dim,int num_procs){
+int MeshPartitionx(int** pepart, int** pnpart, int numberofelements,int numberofnodes,IssmDouble* elements,
+		int numberofelements2d,int numberofnodes2d,IssmDouble* elements2d,int numlayers,int elements_width, int dim,int num_procs){
 
 	int noerr=1;
@@ -31,10 +31,10 @@
 
 	if(dim==2){
-		epart=(int*)xmalloc(numberofelements*sizeof(int));
-		npart=(int*)xmalloc(numberofnodes*sizeof(int));
-		index=(int*)xmalloc(elements_width*numberofelements*sizeof(int));
+		epart=xNew<int>(numberofelements);
+		npart=xNew<int>(numberofnodes);
+		index=xNew<int>(elements_width*numberofelements);
 		for (i=0;i<numberofelements;i++){
 			for (j=0;j<elements_width;j++){
-				*(index+elements_width*i+j)=(int)*(elements+elements_width*i+j)-1; //-1 for C indexing in Metis
+				*(index+elements_width*i+j)=reCast<int>(*(elements+elements_width*i+j))-1; //-1 for C indexing in Metis
 			}
 		}
@@ -51,5 +51,5 @@
 			for (i=0;i<numberofnodes;i++)    npart[i]=0;
 		}
-		else _error_("At least one processor is required");
+		else _error2_("At least one processor is required");
 	}
 	else{
@@ -57,11 +57,11 @@
 
 		/*First build concatenated 2d mesh  from 2d_coll and 2d_noncoll: */
-		epart2d=(int*)xmalloc(numberofelements2d*sizeof(int));
-		npart2d=(int*)xmalloc(numberofnodes2d*sizeof(int)); 
-		index2d=(int*)xmalloc(3*numberofelements2d*sizeof(int));
+		epart2d=xNew<int>(numberofelements2d);
+		npart2d=xNew<int>(numberofnodes2d); 
+		index2d=xNew<int>(3*numberofelements2d);
 
 		for (i=0;i<numberofelements2d;i++){
 			for (j=0;j<3;j++){
-				*(index2d+3*i+j)=(int)*(elements2d+3*i+j)-1; //-1 for C indexing in Metis
+				*(index2d+3*i+j)=reCast<int>(*(elements2d+3*i+j))-1; //-1 for C indexing in Metis
 			}
 		}
@@ -78,8 +78,8 @@
 			for (i=0;i<numberofnodes2d;i++)    npart2d[i]=0;
 		}
-		else _error_("At least one processor is required");
+		else _error2_("At least one processor is required");
 
 		/*Extrude epart2d to epart, using numlayers: */
-		epart=(int*)xmalloc(numberofelements*sizeof(int));
+		epart=xNew<int>(numberofelements);
 		
 		count=0;
@@ -92,5 +92,5 @@
 
 		/*Extrude npart2d to npart, using numlayers: */
-		npart=(int*)xmalloc(numberofnodes*sizeof(int));
+		npart=xNew<int>(numberofnodes);
 		
 		count=0;
@@ -108,10 +108,8 @@
 
 	/*Free ressources: */
-	xfree((void**)&index);
-	xfree((void**)&epart2d);
-	xfree((void**)&npart2d);
-	xfree((void**)&index2d);
-
+	xDelete<int>(index);
+	xDelete<int>(epart2d);
+	xDelete<int>(npart2d);
+	xDelete<int>(index2d);
 	return noerr;
-
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.h	(revision 12878)
@@ -6,7 +6,9 @@
 #define _MESHPARTITIONX_H
 
+#include "../../include/include.h"
+
 /* local prototypes: */
-int MeshPartitionx(int** pepart, int** pnpart, int numberofelements,int numberofnodes,double* elements,
-		int numberofelements2d,int numberofnodes2d,double* elements2d,int numlayers,int elements_width, int dim,int numareas);
+int MeshPartitionx(int** pepart, int** pnpart, int numberofelements,int numberofnodes,IssmDouble* elements,
+		int numberofelements2d,int numberofnodes2d,IssmDouble* elements2d,int numlayers,int elements_width, int dim,int numareas);
 	
 #endif /* _MESHPARTITIONX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/ElementSegment.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/ElementSegment.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/ElementSegment.cpp	(revision 12878)
@@ -38,5 +38,5 @@
 	if(    (edge1==IntersectEnum) && (edge2==IntersectEnum) && (edge3==IntersectEnum)   ){
 		/*This case is impossible: */
-		_error_(" error: a line cannot go through 3 different vertices!");
+		_error2_("error: a line cannot go through 3 different vertices!");
 	}
 	else if(    ((edge1==IntersectEnum) && (edge2==IntersectEnum)) || ((edge2==IntersectEnum) && (edge3==IntersectEnum)) || ((edge3==IntersectEnum) && (edge1==IntersectEnum))   ){
Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp	(revision 12878)
@@ -5,5 +5,4 @@
 
 void MeshProfileIntersectionx( double** psegments, int* pnumsegs, int* index, double* x, double* y, int nel, int nods,  Contour** contours,int numcontours){
-
 
 	int i,j,k;
@@ -28,6 +27,6 @@
 
 	/*Allocate: */
-	allsegments=(double**)xmalloc(numcontours*sizeof(double*));
-	allnumsegs=(int*)xmalloc(numcontours*sizeof(int));
+	allsegments=xNew<double*>(numcontours);
+	allnumsegs=xNew<int>(numcontours);
 
 	/*Loop through all contours: */
@@ -53,5 +52,5 @@
 
 	/*Out of all segments, create one common array of segments: */
-	segments=(double*)xmalloc(5*numsegs*sizeof(double));
+	segments=xNew<double>(5*numsegs);
 	count=0;
 	for(i=0;i<numcontours;i++){
Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.h	(revision 12878)
@@ -8,5 +8,5 @@
 
 #include "../../shared/shared.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshSegmentsIntersection.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshSegmentsIntersection.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/MeshSegmentsIntersection.cpp	(revision 12878)
@@ -32,5 +32,5 @@
 	/*Using the segments_dataset dataset, create segments: */
 	numsegs=segments_dataset->Size();
-	segments=(double*)xmalloc(5*numsegs*sizeof(double));
+	segments=xNew<double>(5*numsegs);
 	for(i=0;i<numsegs;i++){
 		Segment* segment=(Segment*)segments_dataset->GetObjectByOffset(i);
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVelx/MinVelx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVelx/MinVelx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVelx/MinVelx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVxx/MinVxx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVxx/MinVxx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVxx/MinVxx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVyx/MinVyx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVyx/MinVyx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVyx/MinVyx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVzx/MinVzx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVzx/MinVzx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVzx/MinVzx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateConstraintsBalancethickness.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateConstraintsBalancethickness.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateConstraintsBalancethickness.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 #include "../../../toolkits/toolkits.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/classes.h"
 #include "../../../shared/shared.h"
 #include "../ModelProcessorx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateLoadsBalancethickness.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateLoadsBalancethickness.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateLoadsBalancethickness.cpp	(revision 12878)
@@ -6,5 +6,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateNodesBalancethickness.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateNodesBalancethickness.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/CreateNodesBalancethickness.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
@@ -46,5 +46,5 @@
 
 	/*Check in 3d*/
-	if(stabilization==3 && dim==3) _error_("DG 3d not implemented yet");
+	if(stabilization==3 && dim==3) _error2_("DG 3d not implemented yet");
 
 	/*First fetch data: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/UpdateElementsBalancethickness.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/UpdateElementsBalancethickness.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Balancethickness/UpdateElementsBalancethickness.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateConstraintsBedSlope.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateConstraintsBedSlope.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateConstraintsBedSlope.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../toolkits/toolkits.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../ModelProcessorx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateLoadsBedSlope.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateLoadsBedSlope.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateLoadsBedSlope.cpp	(revision 12878)
@@ -6,5 +6,5 @@
 #include "../../../toolkits/toolkits.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateNodesBedSlope.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateNodesBedSlope.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/CreateNodesBedSlope.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../toolkits/toolkits.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/UpdateElementsBedSlope.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/UpdateElementsBedSlope.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/BedSlope/UpdateElementsBedSlope.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
@@ -63,9 +63,9 @@
 		parameters->AddObject(new DoubleVecParam(InversionMaxiterPerStepEnum,maxiter,nsteps));
 
-		xfree((void**)&control_type);
-		xfree((void**)&cm_responses);
-		xfree((void**)&cm_jump);
-		xfree((void**)&optscal);
-		xfree((void**)&maxiter);
+		xDelete<int>(control_type);
+		xDelete<double>(cm_responses);
+		xDelete<double>(cm_jump);
+		xDelete<double>(optscal);
+		xDelete<double>(maxiter);
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateDataSets.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../shared/shared.h"
 #include "../../include/include.h"
@@ -124,5 +124,5 @@
 
 		default:
-			_error_("%s%s%s"," analysis_type: ",EnumToStringx(analysis_type)," not supported yet!");
+			_error2_("analysis_type: " << EnumToStringx(analysis_type) << " not supported yet!");
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../io/io.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../shared/shared.h"
 #include "../MeshPartitionx/MeshPartitionx.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateNumberNodeToElementConnectivity.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateNumberNodeToElementConnectivity.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateNumberNodeToElementConnectivity.cpp	(revision 12878)
@@ -23,5 +23,5 @@
 	int    numberofelements;
 	int    numberofvertices;
-	double* elements=NULL;
+	IssmDouble* elements=NULL;
 
 	/*output*/
@@ -43,5 +43,5 @@
 
 	/*Allocate ouput*/
-	connectivity=(int*)xcalloc(numberofvertices,sizeof(int));
+	connectivity=xNewZeroInit<int>(numberofvertices);
 
 	/*Get element width (3 or 6)*/
@@ -56,5 +56,5 @@
 	for (i=0;i<numberofelements;i++){
 		for (j=0;j<elementswidth;j++){
-			vertexid=(int)elements[elementswidth*i+j];
+			vertexid=reCast<int>(elements[elementswidth*i+j]);
 			_assert_(vertexid>0 && vertexid-1<numberofvertices);
 			connectivity[vertexid-1]+=1;
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 12878)
@@ -13,5 +13,5 @@
 #include "../../toolkits/toolkits.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../shared/shared.h"
 #include "../MeshPartitionx/MeshPartitionx.h"
@@ -24,6 +24,7 @@
 	int         numoutputs;
 	Parameters *parameters       = NULL;
-	double     *requestedoutputs = NULL;
-	
+	IssmDouble *requestedoutputs = NULL;
+	bool        isdelta18o;
+
 	if(*pparameters)return; //do not create parameters twice!
 
@@ -57,5 +58,5 @@
 	parameters->AddObject(iomodel->CopyConstantObject(ThermalPenaltyFactorEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsLowmemEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(DebugPetscProfilingEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(DebugProfilingEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(MeshAverageVertexConnectivityEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(ConstantsReferencetemperatureEnum));
@@ -89,4 +90,26 @@
 	parameters->AddObject(iomodel->CopyConstantObject(InversionIscontrolEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(InversionTaoEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(SurfaceforcingsIspddEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(SurfaceforcingsIsdelta18oEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(SurfaceforcingsIssmbgradientsEnum));
+
+	iomodel->Constant(&isdelta18o,SurfaceforcingsIsdelta18oEnum);
+	if(isdelta18o){
+		IssmDouble *temp = NULL;
+		IssmDouble  yts;
+		int         N,M;
+
+		iomodel->Constant(&yts,ConstantsYtsEnum);
+
+		iomodel->FetchData(&temp,&N,&M,SurfaceforcingsDelta18oEnum); _assert_(N==2);
+		for(i=0;i<M;i++) temp[M+i]=yts*temp[M+i];
+		parameters->AddObject(new TransientParam(SurfaceforcingsDelta18oEnum,&temp[0],&temp[M],M));
+		xDelete<IssmDouble>(temp);
+
+		iomodel->FetchData(&temp,&N,&M,SurfaceforcingsDelta18oSurfaceEnum); _assert_(N==2);
+		for(i=0;i<M;i++) temp[M+i]=yts*temp[M+i];
+		parameters->AddObject(new TransientParam(SurfaceforcingsDelta18oSurfaceEnum,&temp[0],&temp[M],M));
+		xDelete<IssmDouble>(temp);
+	}
 
 	/*some parameters that did not come with the iomodel: */
@@ -104,13 +127,13 @@
 	parameters->AddObject(new IntParam(DiagnosticNumRequestedOutputsEnum,numoutputs));
 	if(numoutputs)parameters->AddObject(new IntVecParam(DiagnosticRequestedOutputsEnum,requestedoutputs,numoutputs));
-	xfree((void**)&requestedoutputs);
+	xDelete<IssmDouble>(requestedoutputs);
 	iomodel->FetchData(&requestedoutputs,&numoutputs,NULL,TransientRequestedOutputsEnum);
 	parameters->AddObject(new IntParam(TransientNumRequestedOutputsEnum,numoutputs));
 	if(numoutputs)parameters->AddObject(new IntVecParam(TransientRequestedOutputsEnum,requestedoutputs,numoutputs));
-	xfree((void**)&requestedoutputs);
+	xDelete<IssmDouble>(requestedoutputs);
 	iomodel->FetchData(&requestedoutputs,&numoutputs,NULL,SteadystateRequestedOutputsEnum);
 	parameters->AddObject(new IntParam(SteadystateNumRequestedOutputsEnum,numoutputs));
 	if(numoutputs)parameters->AddObject(new IntVecParam(SteadystateRequestedOutputsEnum,requestedoutputs,numoutputs));
-	xfree((void**)&requestedoutputs);
+	xDelete<IssmDouble>(requestedoutputs);
 	
 	/*Before returning, create parameters in case we are running Qmu or control types runs: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateSingleNodeToElementConnectivity.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateSingleNodeToElementConnectivity.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/CreateSingleNodeToElementConnectivity.cpp	(revision 12878)
@@ -23,5 +23,5 @@
 	int    numberofelements;
 	int    numberofvertices;
-	double* elements=NULL;
+	IssmDouble* elements=NULL;
 
 	/*output*/
@@ -44,5 +44,5 @@
 
 	/*Allocate ouput*/
-	connectivity=(int*)xcalloc(numberofvertices,sizeof(int));
+	connectivity=xNewZeroInit<int>(numberofvertices);
 
 	/*Get element width (3 or 6)*/
@@ -59,5 +59,5 @@
 		if(iomodel->my_elements[i]){
 			for (j=0;j<elementswidth;j++){
-				vertexid=(int)elements[elementswidth*i+j];
+				vertexid=reCast<int>(elements[elementswidth*i+j]);
 				_assert_(vertexid>0 && vertexid-1<numberofvertices);
 				connectivity[vertexid-1]=i+1;
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp	(revision 12878)
@@ -6,5 +6,5 @@
 #include "../../../toolkits/toolkits.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../../io/io.h"
@@ -15,5 +15,5 @@
 void CreateParametersDakota(Parameters** pparameters,IoModel* iomodel,int solution_type,int analysis_type){
 
-	/*variable declarations: {{{1*/
+	/*variable declarations: {{{*/
 	int i,j,k;
 	
@@ -73,18 +73,18 @@
 		iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
 
-		/*name of qmu input, error and output files:{{{1*/
-		qmuinname=(char*)xmalloc((strlen(name)+strlen(".qmu.in")+1)*sizeof(char));
+		/*name of qmu input, error and output files:{{{*/
+		qmuinname=xNew<char>((strlen(name)+strlen(".qmu.in")+1));
 		sprintf(qmuinname,"%s%s",name,".qmu.in");
 		parameters->AddObject(new   StringParam(QmuInNameEnum,qmuinname));
 
-		qmuoutname=(char*)xmalloc((strlen(name)+strlen(".qmu.out")+1)*sizeof(char));
+		qmuoutname=xNew<char>((strlen(name)+strlen(".qmu.out")+1));
 		sprintf(qmuoutname,"%s%s",name,".qmu.out");
 		parameters->AddObject(new   StringParam(QmuOutNameEnum,qmuoutname));
 
-		qmuerrname=(char*)xmalloc((strlen(name)+strlen(".qmu.err")+1)*sizeof(char));
+		qmuerrname=xNew<char>((strlen(name)+strlen(".qmu.err")+1));
 		sprintf(qmuerrname,"%s%s",name,".qmu.err");
 		parameters->AddObject(new   StringParam(QmuErrNameEnum,qmuerrname));
 		/*}}}*/
-		/*Fetch variable descriptors: {{{1*/
+		/*Fetch variable descriptors: {{{*/
 		iomodel->FetchData(&variabledescriptors,&numvariabledescriptors,QmuVariabledescriptorsEnum);
 
@@ -93,5 +93,5 @@
 
 		/*}}}*/
-		/*Fetch response descriptors: {{{1*/
+		/*Fetch response descriptors: {{{*/
 		iomodel->FetchData(&responsedescriptors,&numresponsedescriptors,QmuResponsedescriptorsEnum);
 
@@ -100,5 +100,5 @@
 		parameters->AddObject(new    IntParam(QmuNumberofresponsesEnum,numberofresponses));
 		/*}}}*/
-		/*Deal with partitioning: {{{1*/
+		/*Deal with partitioning: {{{*/
 		/*partition vertices in iomodel->qmu_npart parts, unless a partition is already present: */
 		
@@ -111,10 +111,10 @@
 			ElementsAndVerticesPartitioning(&iomodel->my_elements,&iomodel->my_vertices,iomodel);
 
-			dpart=(double*)xmalloc(numberofvertices*sizeof(double));
+			dpart=xNew<double>(numberofvertices);
 			for(i=0;i<numberofvertices;i++)dpart[i]=iomodel->my_vertices[i];
 		}
 		parameters->AddObject(new DoubleVecParam(QmuPartitionEnum,dpart,numberofvertices));
 		/*}}}*/
-		/*Deal with data needed because of qmu variables: {{{1*/
+		/*Deal with data needed because of qmu variables: {{{*/
 		
 		for(i=0;i<numvariabledescriptors;i++){
@@ -136,9 +136,9 @@
 				
 				/*Free ressources:*/
-				xfree((void**)&dakota_parameter);
-			}
-		}
-		/*}}}*/
-		/*Deal with data needed to compute qmu responses: {{{1*/
+				xDelete<double>(dakota_parameter);
+			}
+		}
+		/*}}}*/
+		/*Deal with data needed to compute qmu responses: {{{*/
 		for(i=0;i<numresponsedescriptors;i++){
 			
@@ -153,5 +153,5 @@
 			/*Fetch the mass flux segments necessary to compute the mass fluxes.  Build a DoubleMatArrayParam object out of them: */ 
 			iomodel->FetchData(&array,&mdims_array,&ndims_array,&qmu_mass_flux_num_profiles,QmuMassFluxSegmentsEnum);
-			if(qmu_mass_flux_num_profiles==0)_error_(" qmu_mass_flux_num_profiles is 0, when MassFlux computations were requested!");
+			if(qmu_mass_flux_num_profiles==0)_error2_("qmu_mass_flux_num_profiles is 0, when MassFlux computations were requested!");
 
 			/*Go through segments, and extract those that belong to this cpu: */
@@ -166,5 +166,5 @@
 				}
 				if(m){
-					matrix=(double*)xcalloc(5*m,sizeof(double));
+					matrix=xNewZeroInit<double>(5*m);
 					count=0;
 					for(j=0;j<temp_m;j++){
@@ -185,5 +185,5 @@
 
 				/*Free temporary matrix: */
-				xfree((void**)&temp_matrix);
+				xDelete<double>(temp_matrix);
 			}
 
@@ -194,33 +194,33 @@
 			for(i=0;i<qmu_mass_flux_num_profiles;i++){
 				double* matrix=array[i];
-				xfree((void**)&matrix);
-			}
-			xfree((void**)&mdims_array); 
-			xfree((void**)&ndims_array);
-			xfree((void**)&array);
-		}
-		/*}}}*/
-		/*Free data: {{{1*/
+				xDelete<double>(matrix);
+			}
+			xDelete<int>(mdims_array); 
+			xDelete<int>(ndims_array);
+			xDelete<double*>(array);
+		}
+		/*}}}*/
+		/*Free data: {{{*/
 		for(i=0;i<numresponsedescriptors;i++){
 			descriptor=responsedescriptors[i];
-			xfree((void**)&descriptor);
-		}
-		xfree((void**)&responsedescriptors);
+			xDelete<char>(descriptor);
+		}
+		xDelete<char*>(responsedescriptors);
 
 		for(i=0;i<numvariabledescriptors;i++){
 			descriptor=variabledescriptors[i];
-			xfree((void**)&descriptor);
-		}
-		xfree((void**)&variabledescriptors);
-		xfree((void**)&part);
-		xfree((void**)&dpart);
-		xfree((void**)&qmuinname);
-		xfree((void**)&qmuerrname);
-		xfree((void**)&qmuoutname);
+			xDelete<char>(descriptor);
+		}
+		xDelete<char*>(variabledescriptors);
+		xDelete<int>(part);
+		xDelete<double>(dpart);
+		xDelete<char>(qmuinname);
+		xDelete<char>(qmuerrname);
+		xDelete<char>(qmuoutname);
 		/*}}}*/
 	} //if(dakota_analysis)
 
 	/*Free data*/
-	xfree((void**)&name);
+	xDelete<char>(name);
 
 	/*Assign output pointer: */
